
#include "leo.h"
#include "node.h"
//#include "new.cc"
#include <time.h>
#include <fstream>
#include <iostream>
#include <math.h>
using std::ifstream;
#define MAXNODE 10000
#define MAXTIME 100000
#define BASESIZE 150
#define MAX_RANGE 150

#define MAX_NMF_DIM 10

#define TINY 1.0e-10
#define NMAX 500000
int DIM=7; 
int curve=-15;


// GNP Error of each Node
//float min_fit_error2[MAXNODE];
//float min_fit_error4[MAXNODE];
double ftol = 0.00001;

float **medians = NULL;
float **medians_inverse = NULL;
int BETA;
int LANDMARK;
int *idarray;


int nodeCount = 0;
char *outputFormat = NULL;
Node *node1 = NULL;
Node *node2 = NULL;
int *first_beta=NULL;	
int *larray;
int *basic;
int firstin;
int clonei=0;
map<int,int> first_map;
int DIMENSIONS = 10;

FILE *runLogFP = NULL;


FILE* openOutputFile (char *prefix, char *suffix);
void openOutputFile (FILE *&fp, char *prefix, char *suffix, int stamp);
void closeOutputFile (FILE *fp);
void perSecondOutput (int stamp);


void printUsage () {

 /* cout << "vivaldi\n"
       << " -o outprefix\n"
       << " -l trueLatencyMatrixFile\n"
       << " -b BETA(landmark and neighbour number)\n"
       << " -n max nodeid\n"
       << " -s random seed(opt)\n"
       << " -x dimension\n"
       << " -g [ocsrlap] specialize output to... (opt)\n"
       << " -r landmarks number\n"
	<<" -u actual join node\n"
	   << "trueLatencyMatrixFile file should contain lantency between landmarks in same order that they are in landmark file and make sure they are synmetrc;\n"
	   <<"for example: landmark in landmark file : 1\n2\n3\nin matrixfile: 1 1 -1\n1 2 1\n1 3 3\n1 4 2\n2 1 1\n2 2 -1\n...\n";
  */
	
	cout<<"./vivaldi\n"
	<<"required parameters:\n"
	<<"-e:curve number\n"
	<<"-b:neighbor number\n"
	<<"-o:outputprefix, two output:.coord & .time\n"
	<<"-l:.dis file contain landnum* nodeCount matrix\n"
	<<"-x:dimesion\n"
	<<"-m:parameter file name\n"
	<<"-t:input file prefix, .bas, .ord, .nei\n"
	<<"-r:landmark file name\n"
	<<"-------optional parameters\n"
	<<"-u:total input number; if no, means all node join in\n"
	<<"-w: computation method for the rest nodes:0: using the basic landmarks; 1:using ordinary neighbors selection method\n"
	<<"-p: normal landmarks file\n";
  exit (-1);
}



double linear_dist(double *a, double *b) {
	int i;
	double dist;
	
	int norm = 2;
	dist = 0;
	
	for (i=0; i<DIM-2; i++)
	{
		if (norm == 2) {
			dist += (a[i] - b[i])*(a[i] - b[i]);
		} else {
			dist += pow(fabs(a[i] - b[i]), norm);
		}
	}
	
	dist = pow(dist,1.0/norm)+fabs(a[DIM-2]) + fabs(b[DIM-1]);
	
	return dist;
}

	void simplex_downhill1(double **simplex, double *values, int d, double ftol,
						  double (*obj)(double *, int, int), int *num_eval,
						  int stuff) {
			
			  int i, j, low, high, second_high, ssize;
			  double rtol, sum, *simplex_sum, *test_point, test_value, mult;
			
			  *num_eval = 0;
			  ssize = d + 1; /* size of the simplex */
			
			
			  simplex_sum = new double [d+1]; /* array starts at 1 */
			  for (i=1; i<=d; i++) { 
				sum = 0.0;
				for(j=1; j<=ssize; j++) {
				  sum = sum + simplex[j][i];
				}
				simplex_sum[i] = sum;
			  }
			
			
			  test_point = new double [d+1]; /* array starts at 1 */
			
			 
			  while (1) {
				
				if (values[1] > values[2]) {
				  low = 2;
				  high = 1;
				  second_high = 2;
				} else {
				  low = 1;
				  high = 2;
				  second_high = 1;
				}
				for (i=1; i<=ssize; i++) {
				  if (values[i] > values[high]) {
					second_high = high;
					high = i;
				  } else if (values[i] > values[second_high] && i != high) {
					second_high = i;
				  } else if (values[i] <= values[low]) {
					low = i;
				  }
				}
			
			
				rtol=2.0*fabs(values[high]-values[low])/(fabs(values[high])+fabs(values[low])+TINY);
				 
                if (*num_eval >= NMAX || rtol < ftol || values[low] < 1.0e-6) {
				  values[1] = values[low];
				  for (i=1; i<=d; i++) {
					simplex[1][i] = simplex[low][i];
				  }
					cout<<"#######Break:"<<num_eval<<" "<<rtol<<" "<<values[low]<<endl;
				  break;
				}
			
        
				mult = 2.0/d;
				for (i=1; i<=d; i++) {
				  test_point[i] = (simplex_sum[i] - simplex[high][i])*mult - simplex[high][i];
				 
				}
			
				test_value = (*obj)(&test_point[1], d, stuff);
			
				(*num_eval)++;
				if (test_value < values[high]) {
				 
				  values[high] = test_value;
				  for (i=1; i<=d; i++) {
					simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
					simplex[high][i] = test_point[i];
				  }
				}
			
				if (test_value <= values[low]) {
				
				  mult = -1.0/d;
				  for (i=1; i<=d; i++) {
					test_point[i] = (simplex_sum[i] - simplex[high][i])*mult + 2.0*simplex[high][i];
				  
				  }
			
				  test_value = (*obj)(&test_point[1], d, stuff);
			
				  (*num_eval)++;
				  if (test_value < values[high]) {
					
					values[high] = test_value;
					for (i=1; i<=d; i++) {
						simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
						simplex[high][i] = test_point[i];
					}
				  }
			
				} else if (test_value >= values[second_high]) {
				
				  mult = 0.5/d;
				  for (i=1; i<=d; i++) {
					test_point[i] = (simplex_sum[i] - simplex[high][i])*mult + 0.5*simplex[high][i];
				  
				  }
			
				  test_value = (*obj)(&test_point[1], d, stuff);
			
				  (*num_eval)++;
				  if (test_value < values[high]) {
					
                      values[high] = test_value;
					for (i=1; i<=d; i++) {
						simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
						simplex[high][i] = test_point[i];
					}
				  } else {
					
					for (i=1; i<=ssize; i++) {
					if (i != low) {
						for (j=1; j<=d; j++) {
						simplex[i][j]=test_point[j]=0.5*(simplex[i][j]+simplex[low][j]);
						}
						values[i]=(*obj)(&test_point[1], d, stuff);
					}
				}
				*num_eval = *num_eval + d;
			
				for (i=1; i<=d; i++) { 
				  sum = 0.0;
				  for(j=1; j<=ssize; j++) {
					sum = sum + simplex[j][i];
				  }
				  simplex_sum[i] = sum;
				}
				  }
				}
			  }
			
			  delete [] simplex_sum;
			  delete [] test_point;
			
		}
		
		void simplex_downhill2(double **simplex, double *values, int d, double ftol,
					  double (*obj)(double *, int, int), int *num_eval,
					  int stuff) {
		
		
		  int i, j, low, high, second_high, ssize;
		  double rtol, sum, *simplex_sum, *test_point, test_value, mult;
		
		  
		  *num_eval = 0;
		  ssize = d + 1; 
		
		 		  simplex_sum = (double*) malloc(sizeof(double)*(d+1)); 
		  for (i=1; i<=d; i++) { 
			sum = 0.0;
			for(j=1; j<=ssize; j++) {
			  sum = sum + simplex[j][i];
			}
			simplex_sum[i] = sum;
		  }
		
		  
		  test_point = (double*) malloc(sizeof(double)*(d+1)); 
		
		
		  
		  while (1) {
		
			if (values[1] > values[2]) {
			  low = 2;
			  high = 1;
			  second_high = 2;
			} else {
			  low = 1;
			  high = 2;
			  second_high = 1;
			}
			for (i=1; i<=ssize; i++) {
			  if (values[i] > values[high]) {
				second_high = high;
				high = i;
			  } else if (values[i] > values[second_high] && i != high) {
				second_high = i;
			  } else if (values[i] <= values[low]) {
				low = i;
			  }
			}
		
    
			rtol=2.0*fabs(values[high]-values[low])/(fabs(values[high])+fabs(values[low])+TINY);
			if (*num_eval >= NMAX || rtol < ftol || values[low] < 1.0e-6) {
			  values[1] = values[low];
			  for (i=1; i<=d; i++) {
				simplex[1][i] = simplex[low][i];
			  }
			  break;
			}
		
		
			
			mult = 2.0/d;
			for (i=1; i<=d; i++) {
			  test_point[i] = (simplex_sum[i] - simplex[high][i])*mult - simplex[high][i];
			}
		
			test_value = (*obj)(&test_point[1], d, stuff);
		
			(*num_eval)++;
			if (test_value < values[high]) {
			  
			  values[high] = test_value;
			  for (i=1; i<=d; i++) {
				simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
				simplex[high][i] = test_point[i];
			  }
			}
		
			if (test_value <= values[low]) {
			
			  mult = -1.0/d;
			  for (i=1; i<=d; i++) {
				test_point[i] = (simplex_sum[i] - simplex[high][i])*mult + 2.0*simplex[high][i];
			  }
		
			  test_value = (*obj)(&test_point[1], d, stuff);

			 
			  (*num_eval)++;
			  if (test_value < values[high]) {
    
				values[high] = test_value;
				for (i=1; i<=d; i++) {
					simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
					simplex[high][i] = test_point[i];
				}
			  }
		
			} else if (test_value >= values[second_high]) {
            
			  mult = 0.5/d;
			  for (i=1; i<=d; i++) {
				test_point[i] = (simplex_sum[i] - simplex[high][i])*mult + 0.5*simplex[high][i];
			  }
		
			  test_value = (*obj)(&test_point[1], d, stuff);
		
			  (*num_eval)++;
			  if (test_value < values[high]) {
				
				values[high] = test_value;
				for (i=1; i<=d; i++) {
					simplex_sum[i] = simplex_sum[i] - simplex[high][i] + test_point[i];
					simplex[high][i] = test_point[i];
				}
			  } else {
				
				for (i=1; i<=ssize; i++) {
				if (i != low) {
					for (j=1; j<=d; j++) {
					simplex[i][j]=test_point[j]=0.5*(simplex[i][j]+simplex[low][j]);
					}
					values[i]=(*obj)(&test_point[1], d, stuff);
				}
			}
			*num_eval = *num_eval + d;
		
			
			for (i=1; i<=d; i++) { 
			  sum = 0.0;
			  for(j=1; j<=ssize; j++) {
				sum = sum + simplex[j][i];
			  }
			  simplex_sum[i] = sum;
			}
			  }
			}
		  }
    
			delete [] simplex_sum;
			delete [] test_point;
		}
		

double fit_p1(double *array, int num, int backup) 
	{
		double dist, sum, error, actual,actual_inverse,dist_inverse;
		int i, j, temp;
	
		sum = 0;
		for(i=0;i<firstin;i++)
			for(j=0;j<firstin;j++)
			{
				if (i == j) continue;
				actual = medians[basic[i]][first_beta[basic[j]]];
				
				
				actual_inverse = medians_inverse[basic[i]][first_beta[basic[j]]];
				
				if (actual < 0) {
					printf("Fit_p1: No route to the host!\n"); 
					continue;}
				
				dist = linear_dist(&array[i*DIM], &array[j*DIM]);
				dist_inverse = linear_dist(&array[j*DIM], &array[i*DIM]);
			
				
				
				
				
				error = ((dist - actual)/actual)*((dist - actual)/actual);	
				sum += error;
			
				error = ((dist_inverse-actual_inverse)/actual_inverse)*((dist_inverse-actual_inverse)/actual_inverse);
				sum +=error;
			}
	
		return sqrt(sum);
	}



double fit_p4(double *array, int num, int test_node) 
{
	double dist, sum, error, actual,dist_inverse,actual_inverse;
	int i, j, temp;
	
	sum = 0;
	for(i=0;i<firstin;i++)
	{
		temp = basic[i];
		if(temp<0) {printf("first in node is small than 0\n");continue;}
		actual = medians[temp][test_node];
		if (actual < 0) {printf("Fit_p2: No route to the host!"); 
			continue;}
		
			dist = linear_dist(&node2[temp].vec[0],&array[0]);
		error = ((dist - actual)/actual)*((dist - actual)/actual);
		
		sum += error;
		
		
		actual_inverse=medians_inverse[temp][test_node];
		dist_inverse = linear_dist(&array[0],&node2[temp].vec[0]);
		
		error = ((dist_inverse-actual_inverse)/actual_inverse)*((dist_inverse-actual_inverse)/actual_inverse);
		sum+=error;
	}
	return sqrt(sum);
}	

	double fit_p5(double *array, int num, int test_node) 
	{
		double dist, sum, error, actual,actual_inverse,dist_inverse;
		int i, j, temp;
	
		sum = 0;
		for(i=0;i<BETA;i++)
		{
			
			{	
				temp = larray[i];
				int mid=first_map[temp],nid=idarray[temp];
				actual = medians[mid][test_node];
				if (actual<0) {printf("actual is minus\n");continue;}
				
				dist = linear_dist(&node2[nid].vec[0],&array[0]);
				
				error = ((dist - actual)/actual)*((dist - actual)/actual);
				sum += error;
				
				actual_inverse=medians_inverse[mid][test_node];
				
				dist_inverse=linear_dist(&array[0],&node2[nid].vec[0]);
				error = ((dist_inverse-actual_inverse)/actual_inverse)*((dist_inverse-actual_inverse)/actual_inverse);
				sum +=error;
			
			}
			
		}
		return sqrt(sum);
	}	

FILE* openInputFile (char *prefix, char *suffix) {
	FILE *fp;
	char *filename;
	int fileLength = strlen(prefix)+strlen(suffix)+1;
	
	filename = new char [fileLength];
	memset (filename,0,fileLength);
	sprintf (filename, "%s%s", prefix, suffix);
	if ((fp = fopen(filename, "r")) == NULL) {
		printf("%s: file open error.\n", filename);
		exit (-1);
	}
	delete [] filename;
	return fp;
}

				

	

int main (int argc, char **argv) {
  char c =  0;
  char *sampleFile = NULL;
  char *trueLatencyMatrixFile = NULL, *inverseMatrixFile = NULL;
  int seed = getpid();
  int ROUNDS = 0;
  int marks = 0;
//required parameters:
//b:neighbor number
//o:outputprefix, two output:.coord & .time
//l:.dis file contain landnum* nodeCount matrix
//x:dimesion
//m:parameter file name
//t:input file prefix, .bas, .ord, .nei
//r:landmark file name
/////optional
//u:total input number; if no, means all node join in
//w:the computation method select for the rest of landmarks;0: select the basic landmarks; 1: select already in landmarks like ordinory nodes
  FILE *fp;
  char *landmarks= NULL;
  char *outputPrefix = NULL;
	char *markFile = NULL;
 
  int totalnode = 0;
  char *landcoord=NULL;
  char *para=NULL;
  char *inpre=NULL;
  DIM=0;
  BETA=0;
  int landcom=0;
  char *neims=NULL;
  int start=-1;
 // int innn=4301844;
  int omit=0,end=0,treenum=1;

  while ((c = getopt(argc,argv,"b:e:s:o:x:g:m:t:w:i:r:l:u:p:y:v:n:")) >= 0) {
    switch (c) {
    case 'o':
      outputPrefix = optarg;
      break;
    case 'l':
      trueLatencyMatrixFile = optarg;//distance file
      break;
    case 'b':
	  BETA = atoi(optarg);//neighbor number
      break;
    case 'x':
      DIM = atoi(optarg);//dimension
      break;
	case 'm':
	   para=optarg;//paprameter file name
	   break;
	case 't':
		inpre=optarg;
		break;
	case 'r':
	   landmarks = optarg;//landmarks file prefix
	   break;
	case 'u':
           totalnode = atoi(optarg);//optional
           break;
	case 'w':
           landcom=atoi(optarg);
           break;
	case 'p':
		neims=optarg;
		break;
	case 'e':
		curve=atoi(optarg);
		break;	
	case 'y':
		start=atoi(optarg);//-1: only landmark;tree start number:using others
		break;
	case 'v':
		landcoord=optarg;
		break;
	case 'n':
		treenum=atoi(optarg);
		break;
			
   ///////******Xiaohan New July 15////////////////
	case 'i':
		inverseMatrixFile = optarg;//Inverse direction matrix
		break;
		
    default:
      printUsage ();
      break;
    }
  }


  if (outputPrefix == NULL) {
    printf("Output file prefix is required.\n");
    printUsage ();
  }
  if(inpre==NULL)
  {
	  printf("input file prefix is required\n");
	  printUsage();
  }
  if(DIM==0 || BETA==0)
  {
	  printf("DIM and BETA are required\n");
	  printUsage();
  }
  if (para==NULL) {
	  printf("Parameter file is NULL\n");
	  printUsage();
  }
  
  if(landmarks == NULL || trueLatencyMatrixFile==NULL ){
		printf ("Landmark file or matrix file misses\n");
		printUsage ();
  }
  DIMENSIONS=DIM;
  FILE *pfile = fopen(para,"r");
  if(start>treenum)
  {
	cout<<"start:"<<start<<" larger than end:"<<treenum<<endl;
	exit(1);
  }
	
  int highest,closest,nclose,hdegree;
  fscanf(pfile,"%d %d %d\n",&LANDMARK,&highest,&nodeCount);
  
  fscanf(pfile,"%d %d %d %d\n",&firstin,&closest,&nclose,&hdegree);
  fclose(pfile);

  //if (totalnode==0) totalnode=nodeCount;
	cout<<totalnode<<" "<<nodeCount<<endl;
	FILE *fpp=openOutputFile(outputPrefix,".para");
	
	fprintf(fpp,"landmark:%d\n",LANDMARK);
	fprintf(fpp,"highest degree node:%d\n",highest);
	fprintf(fpp,"map node:%d\n",nodeCount);
	fprintf(fpp,"basic landmark number:%d\n",firstin);
	fprintf(fpp,"highest nodes of basic:%d\n",closest);
	fprintf(fpp,"closest number for normal:%d\n",nclose);
	fprintf(fpp,"highest nodes for normal:%d\n\n",hdegree);
	fprintf(fpp,"output prefix:%s\n",outputPrefix);
	fprintf(fpp,"matrix file:%s\n",trueLatencyMatrixFile);
	fprintf(fpp,"landmark file:%s\n",landmarks);
	fprintf(fpp,"input file prefix:%s\n",inpre);
	fprintf(fpp,"parameter name:%s\n",para);
	fprintf(fpp,"neighbour number:%d\n",BETA);
	fprintf(fpp,"demision:%d\n",DIM);
	fprintf(fpp,"landmark comptutation method:%d\n",landcom);
	fprintf(fpp,"sys node:%d\n",totalnode);
	fprintf(fpp,"curvature:%d\n",curve);
	fprintf(fpp,"start tree ID:%d\n",start);
	fprintf(fpp,"end tree ID:%d\n",treenum);
	fprintf(fpp,"inverse matrix: %s\n",inverseMatrixFile);
	fclose(fpp);
  int myId, yourId;
  int stamp = 0;
  float rawLatencySample; 
  FILE *land;
  char filex[100];
  sprintf(filex,"%s%d.time",outputPrefix, start);
  FILE *TimeFile=fopen(filex,"w");
  time_t readstart=time(NULL);
	
	cout<<start<<" "<<omit<<" "<<end<<endl;
	
	
 
  cout<<"map build\n";
  
  if (trueLatencyMatrixFile != NULL && landmarks != NULL) {
	  
	  if ((land = openInputFile(landmarks,".mark"))== NULL){
		  printf ("Cannot open file %s", landmarks);
		  exit (-1);
	  }
	
	first_beta = new int [LANDMARK];
	  
	int num = 0,temp1,temp2;
	int c=0;
	while (fscanf (land, "%d %d %d\n",&temp1,&temp2,&num) >= 0) {   
		  if (num >= 0)
		  {
			  first_beta[c]=num;
			  first_map[num]=c;
			  c++;
		  }
	  }
	fclose (land);
	printf("read landmarks\n");
	  
    if ((fp = fopen (trueLatencyMatrixFile, "r")) == NULL) {
      printf ("Cannot open file %s", trueLatencyMatrixFile);
      exit (-1);
    }

    medians = new float* [LANDMARK];
	  medians_inverse = new float* [LANDMARK];
  
	  idarray = new int[nodeCount];
       for (int myIdT = 0; myIdT < LANDMARK; myIdT++) {
      medians[myIdT] = new float[nodeCount];
		   medians_inverse[myIdT] = new float[nodeCount];
	 for (int yourIdT = 0; yourIdT < nodeCount; yourIdT++) {
		medians[myIdT][yourIdT] = -1; /////////////// 0 -> -1
		 medians[myIdT][yourIdT]=-1;
		 idarray[yourIdT]=-1;
	//	 larray[myIdT][yourIdT]=-1;
      }
    }
	int idin = 0;
	  FILE *test = fopen("test.txt","w");
    while (idin<LANDMARK) {  
		for(int i=0;i<nodeCount;i++)
		{fscanf(fp,"%f ",&medians[idin][i]);fprintf(test,"%d ",int(medians[idin][i]));
		}
		fscanf(fp,"\n");
		fprintf(test,"\n");
		idin++;
    }
	  fclose (fp);
	  fclose(test);
	  test = fopen("test_inverse.txt","w");
	  ///////******Xiaohan New July 15////////////////
	  if ((fp = fopen (inverseMatrixFile, "r")) == NULL) {
		  printf ("Cannot open file %s", inverseMatrixFile);
		  exit (-1);
	  }
	  idin = 0;
	  while (idin<LANDMARK) {  
		  for(int i=0;i<nodeCount;i++)
		  {
			  fscanf(fp,"%f ",&medians_inverse[idin][i]);fprintf(test,"%d ",int(medians_inverse[idin][i]));
		  }
		  fscanf(fp,"\n");
		  fprintf(test,"\n");
		  idin++;
	  }
	  fclose(fp);
	  fclose(test);
  } 

	
	FILE *NUMfile = openInputFile(inpre,".num");
	map<int,int> numMap;
	int tempnum,temptreeid;
	while(fscanf(NUMfile,"%d %d\n",&temptreeid,&tempnum)>=0)
	{
		numMap[temptreeid]=tempnum;
	}
	fclose(NUMfile);
	
 // FILE *rtime = openOutputFile (outputPrefix, ".time");
	
    time_t readend=time(NULL);
 /////////////////////////////////////////////////////////////////
  
/////////////////////////////////////////////////////////////////
	fprintf(TimeFile,"%ld\n",(int)(readend-readstart));
 
   	{
	int ii, jj, kk;	
	int count=0;
	node1 = new Node[LANDMARK];	// Basic
	for(ii=0;ii<totalnode;ii++) {//node1_1[ii].Refresh();
		node1[ii].Refresh();
	}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	int joinnum=0;
	if(start==-1)
	{

		    int a, b, i, j;
			int total_try1, total_try2;
			int num = DIM * firstin;		
			double localftol = ftol;
			int num_eval;
			int stuff;
	      //select the first join in basic landmark which are used into Global Simplex Downhill
			basic = new int[firstin];
			int jo=0;
			//double landtime=0, nortime=0;
		node2 = new Node[LANDMARK];
		totalnode=LANDMARK;
		cout <<"total node:"<<totalnode<<endl;;
		for(int im=0;im<LANDMARK;im++)
		{
			node2[im].Refresh();
		}
	        
			FILE *basf=openInputFile(landmarks,".bas");
			while(fscanf(basf,"%d\n",&basic[jo])>=0)
			{
								
				printf("%d\n",basic[jo]);
				jo++;
			}
			fclose(basf);
			double min_fit = 100000000;
			double **p0;
			printf("start compute basic landmarks...\n");
			p0 = new double*[DIM*firstin+1+1];
			for(int tr=0; tr< DIM*firstin+1+1; tr++)
			{
				p0[tr] = new double [DIM*firstin+1];
			}
			double *y0 = new double[DIM*firstin+1+1];
			int innum=firstin;
			for(total_try1 = 0; total_try1 < 3; total_try1++)
			{
				printf("try1:%d\n",total_try1);
				for(total_try2 = 0; total_try2 < 3; total_try2++)
				{
					printf("try2:%d\n",total_try2);
					if (total_try2 == 0)
					{
						a = 1;
						for(b=1;b<=DIM*firstin;b++)
						{	
							//p0[a][b] = (double)(rand() % 500 - 250);
							p0[a][b] = (double)(rand() % 10000 - 5000);				
						}				
						y0[a] = fit_p1(&p0[a][1], DIM*firstin, 0); //printf("%.2f ", y0[a]);
						cout<<total_try1<<" "<<total_try2<<"******"<<y0[a]<<" ";
			
						for(a=2;a<=DIM*firstin+1;a++)
						{
							for(b=1;b<=DIM*firstin;b++)
							{	
								p0[a][b] = p0[1][b];
 				//				printf("a:%d;b:%d\n",a,b);				
							}				
							p0[a][a-1] += 40000;
			
							y0[a] = fit_p1(&p0[a][1], DIM*firstin, 0); //printf("%.2f ", y0[a]);
							cout<<y0[a]<<" ";
						}
						cout<<endl;
					}
					else
					{
						y0[1] = fit_p1(&p0[1][1], DIM*firstin, 0); //printf("%.2f ", y0[1]);
						cout<<total_try1<<" "<<total_try2<<"******"<<y0[a]<<" ";
						for(a=2;a<=DIM*firstin+1;a++)
						{							
							for(b=1;b<=DIM*firstin;b++)
							{	
								p0[a][b] = p0[1][b];					
							}
								
							//p0[a][a-1] += 2000; 
							p0[a][a-1] += 40000;
							y0[a] = fit_p1(&p0[a][1], DIM*firstin, 0); //printf("%.2f ", y0[a]);
							cout<<y0[a]<<" ";
						}
						cout << endl;
					}
					simplex_downhill1(p0,y0,num,localftol,fit_p1,&j,i);
	
					if (fit_p1(&p0[1][1], DIM*firstin, 0) < min_fit)
					{
						//printf("fit_p1 used here\n");
						min_fit = fit_p1(&p0[1][1], DIM*firstin, 0);
						printf("%lf\n",min_fit);
						//printf("fit_p1 used here two\n");
						for(i=0;i<firstin;i++)
						{
							for(j=0;j<DIM;j++)
							{
								node1[basic[i]].vec[j]= p0[1][i*DIM+j+1];
								node2[basic[i]].vec[j]= p0[1][i*DIM+j+1];
								//printf("landmark in\n");
							}
						}
					}
					//printf("fit_p1 used \n");
				}
			}
	
	FILE *lands=openOutputFile(outputPrefix, ".land");
	  for(int ki = 0; ki<firstin;ki++)
	  {	
		  idarray[first_beta[basic[ki]]]=joinnum;
		  cout<<"Join basic:"<<basic[ki]<<" "<<first_beta[basic[ki]]<<endl;
		  joinnum++;
		  fprintf(lands,"%d ",first_beta[basic[ki]]);
		  for(int kj =0; kj<DIM;kj++)
			  fprintf(lands,"%f ",node1[basic[ki]].vec[kj]);
		  fprintf(lands,"\n");
	  }
	  
	  for(int tr=0; tr< DIM*firstin+1+1; tr++)
	  {
		  delete [] p0[tr];
	  }
	  delete [] y0;
	  delete [] p0;
	

			// Layer1 GNP (Pure GNP, Node4[])
		double **p;
		p = new double* [DIM+1+1];
		for(int trr=0;trr<DIM+1+1;trr++)
		{
			p[trr]=new double[DIM+1];
		}
		double *y= new double[DIM+1+1];
		larray=new int[BETA];
		FILE *ordf=openInputFile(landmarks,".sec");

		map<int,int> mar;
		map<int,int>::iterator mIter;
		double *tempv;
		tempv = new double[DIM];
		
		for(int ii=0;ii<LANDMARK-firstin;ii++)
			{
				int join=0;
				int ok=0;
				fscanf(ordf,"%d\n",&join);
				mar.clear();
				if(landcom)
				{
					int count = 0,nein=0;
					cout<<"join:"<<join<<" "<<first_map[join]<<" "<<idarray[join]<<endl;
					if(idarray[join]>=0) {cout<<"already join in the system:"<<join<<endl;exit(1);}
					idarray[join]=joinnum;
					joinnum++;
					
					int neix=0;
					int rein=0;
					int jtemp=0;
					int neicount=0;
					int hig=0;
					clonei=0;
					
					while(hig<hdegree && count<BETA){
						int x=rand()%highest;
						int id=first_beta[x];
						mIter=mar.find(id);
						if(mIter==mar.end() && join!=id && idarray[id]>=0)
							{
								larray[count]=id;
								mar[id]=1;
								count++;
								hig++;
								//cout<<hig<<" "<<x<<endl;
							}
						continue;
					
					}
					cout<<"high degree nodes\n";
					while(count<BETA)
					{
						int x=rand()%(LANDMARK-highest)+highest;
						int id=first_beta[x];
						mIter=mar.find(id);
						
						if(mIter==mar.end() && join!=id && idarray[id]>=0) 
						{
							larray[count]=id;
							mar[id]=1;
							count++;
						}
						continue;
					}	
					cout<<"neigh select\n"<<endl;	
				}

				//printf("JOIN NODE:%d\n",ii);
				{
			
				int num = DIM;		
				double localftol = ftol;
				
				//double min_fit = 10000;
				double min_fit = 100000000;
				map<int,int>::iterator it;
				it=first_map.find(join);
				int a, b;
				int tmp_j;
				
				for(int total_try1 = 0; total_try1 < 3; total_try1++)
				{
					for(int total_try2 = 0; total_try2 < 3; total_try2++)
					{
						if (total_try2 == 0)
						{
							for(a=1;a<=DIM+1;a++)
							{
								for(b=1;b<=DIM;b++)
								{	
									//p[a][b] = (double)(rand() % 500 - 250); 
									p0[a][b] = (double)(rand() % 10000 - 5000);	
								}				
								if (a>1) p[a][a-1]+=40000;//p[a][a-1] += 2000;
								if(!ok) y[a] = fit_p5(&p[a][1], DIM, join); //printf("%.2f ", y[a]);
								else y[a]=fit_p4(&p[a][1],DIM,join);
							}
						}
						else
						{
							if(!ok) y[1] = fit_p5(&p[1][1], DIM, join); 
							else y[1]=fit_p4(&p[1][1],DIM,join);
							for(a=2;a<=DIM+1;a++)
							{
							
								for(b=1;b<=DIM;b++)
								{
									p[a][b] = p[1][b];					
								}
								//p[a][a-1] += 2000;
								p[a][a-1]+=40000;
						
								if(!ok) y[a] = fit_p5(&p[a][1], DIM, join); 
								else y[a] = fit_p4(&p[a][1], DIM, join); 
							}
						}
						if(!ok) simplex_downhill2(p,y,num,localftol,fit_p5,&tmp_j,join);
						else simplex_downhill2(p,y,num,localftol,fit_p4,&tmp_j,join);

						if (!ok){
							if(fit_p5(&p[1][1], DIM, join) < min_fit)
							{
								min_fit = fit_p5(&p[1][1], DIM, join);
								for(int jj=0;jj<DIM;jj++)
								{
									node1[idarray[join]].vec[jj]=p[1][jj+1];
									node2[idarray[join]].vec[jj]=p[1][jj+1];
								}
									//tempv[jj]=p[1][jj+1];
							}
						}
						/*else {
							if(fit_p4(&p[1][1], DIM, join) < min_fit)
							{
								min_fit = fit_p4(&p[1][1], DIM, join);
								for(int jj=0;jj<DIM;jj++)
									node1[join].vec->v[jj] = p[1][jj+1];
								node1[join].lastUpdateTo = 1; // !!!!!!!!!!!!
							}
						}*/

						//printf("fi1 end\n");
						//cout<<"coordinate write in\n"<<endl;
					}

				}
				 
				 fprintf(lands,"%d ",join);
				 for(int dl = 0; dl<DIM; dl++)
				 {
					 fprintf(lands,"%f ",node1[idarray[join]].vec[dl]);
				 }
				 fprintf(lands,"\n");
				 //cout<<"write into files\n";
				}
			}
		delete [] node1;
		return 1;
	}
	else{
		/*FILE *lands=fopen(landcoord,"r");
		joinnum=0;
	
		for(int i=0;i<LANDMARK;i++)
		{

			int id;
			fscanf(lands,"%d ",&id);
			idarray[id]=joinnum;
			joinnum++;
			if(id==3072440) cout<<"Landmark contains:3072440"<<endl;
			//int x=first_map[id];
			for(int j=0;j<DIM;j++)
			{
				double y;
				fscanf(lands,"%lf ",&y);
				node1[idarray[id]].vec->v[j]=y;
			}
			fscanf(lands,"\n");
		}
		fclose(lands);*/
		for(int treeid=start;treeid<treenum && treeid<LANDMARK;treeid++)
	    {
			
			char outx[100];
			joinnum=0;
			sprintf(outx,"%s%d",outputPrefix,treeid);
			runLogFP=openOutputFile(outx,".coord");
			totalnode=numMap[treeid];
			cout<<"In tree "<<treeid<<" there are "<<totalnode<<endl;
			node2 = new Node[totalnode+LANDMARK];
			/*for(int im=0;im<totalnode+LANDMARK;im++)
			{
				if(im<LANDMARK)
				{
					for(int xo=0;xo<DIM;xo++)
					{
						node2[im].vec->v[xo]=node1[im].vec->v[xo];
					}
					cout<<"in landmark:"<<im<<"; "<<xo<<endl;
				}
				else {
					node2[im].Refresh();
				}
				//cout<<im<<endl;
			}
			joinnum=LANDMARK;*/
			FILE *lands=fopen(landcoord,"r");
			for(int i=0;i<nodeCount;i++)
			{
				idarray[i]=-1;
			}
			joinnum=0;
			for(int i=0;i<LANDMARK;i++)
			{
				
				int id;
				fscanf(lands,"%d ",&id);
				idarray[id]=joinnum;
				joinnum++;
				//if(id==3072440) cout<<"Landmark contains:3072440"<<endl;
				//int x=first_map[id];
				int j=0;
				for(j=0;j<DIM;j++)
				{
					double y;
					fscanf(lands,"%lf ",&y);
					node2[idarray[id]].vec[j]=y;
				}
				fscanf(lands,"\n");
				//cout<<"landmark "<<i<<" joining:"<<j<<endl;
			}
			fclose(lands);
			
			for(int i=LANDMARK;i<totalnode+LANDMARK;i++)
			{
				node2[i].Refresh();
			}
			
			cout<<"Landmark joined into node2:"<<joinnum<<endl;
			double **p;
			p = new double* [DIM+1+1];
			for(int trr=0;trr<DIM+1+1;trr++)
			{
				p[trr]=new double[DIM+1];
			}
			double *y= new double[DIM+1+1];
			larray=new int[BETA];
			char inpx[100];
			sprintf(inpx,"%s%d",inpre,treeid);
			FILE *ordf=openInputFile(inpx,".ord");

			map<int,int> mar;
			map<int,int>::iterator mIter;

			for(int ii=0;ii<totalnode;ii++)
			{
				int join=0;
				int ok=0;
				clonei=0;
				mar.clear();
				{
					int count = 0,nein=0;
					//fscanf(ordf,"%d %d\n",&join,&nein);
					
					
					//////***********xiaohan July 18//////////////
					fscanf(ordf,"%d",&join);
					if(idarray[join]>=0) {cout<<"already join in the system:"<<join<<endl;exit(1);}
					idarray[join]=joinnum;
					joinnum++;
				
					/*if(nclose==1)
						{
							mar[nein]=1;
							larray[count]=nein;
							count++;
							clonei=1;
						}
					*/
					
				 
				cout<<"join:"<<join<<" close nei:"<<clonei<<" "<<count<<endl;
			
				//srand(time(NULL)+join);
				int hig=0;
				while(count<BETA)
				{
					fscanf(ordf,"%d ",&nein);
					mar[nein]=1;
					larray[count]=nein;
					count++;
					hig++;
				}
				
					cout<<"high degree nodes "<<hig<<" "<<count<<endl;;
				
			
			}
			
			//printf("JOIN NODE:%d\n",ii);
			{
				cout<<"start to compute "<<ii<<endl;
				
				int num = DIM;		
				double localftol = ftol;
				double min_fit = 100000000;
				map<int,int>::iterator it;
				it=first_map.find(join);
				int a, b;
				int tmp_j;
				
				for(int total_try1 = 0; total_try1 < 3; total_try1++)
				{
					for(int total_try2 = 0; total_try2 < 3; total_try2++)
					{
						if (total_try2 == 0)
						{
							for(a=1;a<=DIM+1;a++)
							{
								for(b=1;b<=DIM;b++)
								{	
									//p[a][b] = (double)(rand() % 500 - 250); 
									p[a][b] = (double)(rand() % 10000 - 5000);	
								}				
								if (a>1) p[a][a-1]+=40000;//p[a][a-1] += 2000;
								if(!ok) y[a] = fit_p5(&p[a][1], DIM, join); //printf("%.2f ", y[a]);
								else y[a]=fit_p4(&p[a][1],DIM,join);
							}
						}
						else
						{
							//cout<<total_try1<<" "<<total_try2<<"fit_p5"<<endl;
							if(!ok) y[1] = fit_p5(&p[1][1], DIM, join); //printf("%.2f ", y[1]);
							else y[1]=fit_p4(&p[1][1],DIM,join);
							for(a=2;a<=DIM+1;a++)
							{
								
								for(b=1;b<=DIM;b++)
								{	
									p[a][b] = p[1][b];					
								}
								//p[a][a-1] += 2000;
								p[a][a-1]+=40000;
								
								if(!ok) y[a] = fit_p5(&p[a][1], DIM, join); //printf("%.2f ", y[a]);
								else y[a] = fit_p4(&p[a][1], DIM, join); 
							}
							//cout<<total_try1<<" "<<total_try2<<"fit_p5 ends"<<endl;
						}
						if(!ok) simplex_downhill2(p,y,num,localftol,fit_p5,&tmp_j,join);
						else simplex_downhill2(p,y,num,localftol,fit_p4,&tmp_j,join);
						//	printf("simplex_downhill2 \n");
						//				printf("%.2f J%d  ", fit_p4(&p[1][1], DIM, ii), tmp_j);
						//cout<<"simlex downhill"<<total_try1<<' '<<total_try2<<endl;
						if (!ok){
							if(fit_p5(&p[1][1], DIM, join) < min_fit)
							{
								min_fit = fit_p5(&p[1][1], DIM, join);
								for(int jj=0;jj<DIM;jj++)
								{
									node2[idarray[join]].vec[jj] = p[1][jj+1];
									//tempv[jj]=p[1][jj+1];
								}
							}
						}
					}
					
				}
				fprintf(runLogFP,"%d ",join);
				int tr=idarray[join];
				for(int dl = 0; dl<DIM; dl++)
				{
					fprintf(runLogFP,"%f ",node2[tr].vec[dl]);
				}
				fprintf(runLogFP,"\n");
				
			}
		}
		fclose(runLogFP);
		delete [] node2;
		delete [] larray;
		
			for(int trr=0;trr<DIM+1+1;trr++)
			{
				delete [] p[trr];
			}
			delete [] p;
			delete [] y;
			//delete [] larray;
			mar.clear();
	}
	}
	


}
time_t endcom=time(NULL);
fprintf(TimeFile,"%ld\n",(int)(endcom-readend));

fclose(TimeFile);
  if (medians != NULL) {
    for (int myId = 0; myId < LANDMARK; myId++) {
      delete [] medians[myId];
    }
    delete [] medians;
	//delete [] larray;
  }

  return 0;
}


FILE* openOutputFile (char *prefix, char *suffix) {
  FILE *fp;
  char *filename;
  int fileLength = strlen(prefix)+strlen(suffix)+1;

  filename = new char [fileLength];
  memset (filename,0,fileLength);
  sprintf (filename, "%s%s", prefix, suffix);
  if ((fp = fopen(filename, "w")) == NULL) {
    printf("%s: file open error.\n", filename);
    exit (-1);
  }
  delete [] filename;
  return fp;
}

void openOutputFile (FILE *&fp, char *prefix, char *suffix, int round) {
  char *filename;
  int fileLength = strlen(prefix)+strlen(suffix)+32;

  filename = new char [fileLength];
  memset (filename,0,fileLength);
  sprintf (filename, "%s%05d%s", prefix, round, suffix);
  if ((fp = fopen(filename, "w")) == NULL) {
    printf("%s: file open error.\n", filename);
    exit (-1);
  }
  delete [] filename;
}

void closeOutputFile (FILE *fp) {
  fclose (fp);
  fp = NULL;
}




